package com.sun.corba.se.impl.protocol;

import javax.rmi.CORBA.Tie;
import org.omg.CORBA.Object;
import com.sun.corba.se.spi.ior.IOR;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.CORBA.portable.ServantObject;

public class JIDLLocalCRDImpl extends LocalClientRequestDispatcherBase
{
    protected ServantObject servant;
    
    public JIDLLocalCRDImpl(ORB orb, int n, IOR ior) {
        super(orb, n, ior);
    }
    
    public ServantObject servant_preinvoke(org.omg.CORBA.Object object, String s, Class clazz) {
        if (!this.checkForCompatibleServant(this.servant, clazz)) {
            return null;
        }
        return this.servant;
    }
    
    public void servant_postinvoke(org.omg.CORBA.Object object, ServantObject servantObject) {
    }
    
    public void setServant(Object o) {
        if (o != null && o instanceof Tie) {
            this.servant = new ServantObject();
            this.servant.servant = ((Tie)o).getTarget();
        }
        else {
            this.servant = null;
        }
    }
    
    public void unexport() {
        this.servant = null;
    }
}
